#include <stdio.h>
#include <vector>
using namespace std;

int v,e,a,b;
vector<int> neigh[250];
int col[250];


bool ok(int v, int c) {
	if (col[v]!=0) return col[v]==c;
	col[v]=c;
	bool ret = true;
	for (int i=0; i<neigh[v].size(); i++) ret &= ok(neigh[v][i], -c);
	return ret;
}

int main() {

	while (true) {
		scanf("%d",&v);
		if (!v) break;
		scanf("%d",&e);

		for (int i=0;i<250;i++) {
			neigh[i] = vector<int>();
			col[i] = 0;
		}

		while (e--) {
			scanf("%d %d", &a, &b);
			neigh[a].push_back(b);
			neigh[b].push_back(a);
		}

		printf("%s\n", ok(0,1) ? "BICOLORABLE." : "NOT BICOLORABLE.");
	}
}
